<?php
/*
 * RemotExam - simple remote one-time pseudorandom draw of exam question-paper online
 * Copyright (c) 2020 Sunkware
 * PubKey FP: 6B6D C8E9 3438 6E9C 3D97  56E5 2CE9 A476 99EF 28F6
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * [ WWW: https://sunkware.org ]                       [ E-MAIL: sunkware@gmail.com ]
 */
?>
<?php
// begin config
	// "□□□□"-s are to be replaced with publicly known values, like site URL
	// "████"-s are to be replaced with values KNOWN ONLY TO YOU, like passwords. Where they need to be random, such as "qEw78w8uG7ZpOTQiGopiaT3ISzsEtjcR", use e.g. "$ apg -s -a 1 -m 32 -M ncl"
	define("THIS_TITLE", 'RemotExam™');
	define("THIS_VERSION", '1.0.2');
	define("THIS_COPYR", '© 2020 Sunkware');
	define("ADMINPASS_SHA256HASH", '████████████████████████████████████████████████████████████████'); // Get SHA-256 (hexadec, lowercase) of your Pa5sW#rD by e.g. "$ echo -n 'Pa5sW#rD' | sha256sum -"
	define("SCRIPTIME_MAILSEND_LIMIT", 600); // there's mail sending... is 10 min enough or too long?
	define("PARTICIPANT_LINK_PREFIX", 'https://□□□□□□□□□□□□□□□□.□□□/remotexam.php?id=');
	define("PARTICIPANT_EMAIL_SENDER", 'noreply@□□□□□□□□□□□□□□□□.□□□');
	define("PARTICIPANT_EMAIL_SUBJECT", 'Your RemotExam link');
	define("ID_STRING_LENGTH", 32);
	define("SALT_STRING_LENGTH", 4);
	define("DATABASE_HOST", '████████.███');
	define("DATABASE_NAME", '████████_████████');
	define("DATABASE_USER", '████████_████████');
	define("DATABASE_PASS", '████████████████████████████████');
	define("DATABASE_CHARSET", 'utf8');
	define("IP_ALLOWED_CHARS", '.:0123456789abcdefABCDEF');
	define("MAX_IP_STRING_LENGTH", 128); // probably too much...
	define("MAX_STORED_IP_ADDRESSES", 128); // set to 0 if you do not want to collect IPs at all
	define("DATA_PATHDIR", 'remotexam/████████████████████████████████/'); // 'remotexam' and exam id-s may be too easy to guess...
	define("IMAGE_DATA_MIME", 'image/png');
	define("IMAGE_FILE_EXT", '.png');
	define("VARIMG_FILENAME_PREFIX", 'var_');
	define("VEILIMG_FILENAME", 'veil.png');

	define("HASHCALC_INSALT", '████████████████████████████████');

	define("FAVICON_FILENAME", 'favicon.png');
	define("EMBLEM_FILENAME", 'emblem.png');
	define("EMBLEM_SIZE", 70);
	define("EMBLEM_MARGIN", 4);
	define("EMBLEM_OPACITY", '0.75');
	define("EMBLEM_JUMPDURATION", '1');
	define("EMBLEM_HREF", "https://sunkware.org/remotexam/"); // more options for emblem than for anything else?..

	define("ERRSTR_DB_FAILCONNECT", 'Database connection failed');
	define("ERRSTR_DB_ERR", 'Database error');
	define("ERRSTR_ID_NONE", 'ID?');
	define("ERRSTR_ID_ERR", "<span title=\"sorry, no SQL injections today\">ID error</span>");
	define("ERRSTR_ID_NOT_FOUND", 'ID not found');
	define("ERRSTR_EXAM_NOT_FOUND", 'Exam not found');
	define("ERRSTR_VARS_NOT_FOUND", 'Variants not found');

	define("LOCALE_INSTRUCT_CHOICE", 'Select a digit in each row and click OK.<br>The code you enter defines your variant pseudorandomly.');
	define("LOCALE_NO_EXAM_NOW", 'You have no exam currently.');
	define("LOCALE_PAGE_VISITORS", 'This page has been visited from IP address(es)');
// end config

	define("THISCRIPT", $_SERVER['PHP_SELF']);
	define("THIS_IS_LOCAL", file_exists('../.local'));


	function str_rm_quotes($str) {
		return str_replace(array("'", "`", "\""), "", $str); // $str can be array of strings as well
	}

	function check_id_str($id_str) { // format checks (to avoid SQL-inj. etc.)
		return ( (strlen($id_str) == ID_STRING_LENGTH) && ctype_digit($id_str) );
	}

	function terminate($echostr) {
?>
		<p style="background: black; color: red; font-size: 200%; line-height: 3; text-align: center;"><b>&nbsp;<?=$echostr?></b></p>
	</body>
</html>
<?php
		exit();
	}


	$dbhost = THIS_IS_LOCAL ? "localhost" : DATABASE_HOST;

	$mysqli = new mysqli($dbhost, DATABASE_USER, DATABASE_PASS, DATABASE_NAME);
	if ($mysqli->connect_errno) {
		die(ERRSTR_DB_FAILCONNECT);
	}
	mysqli_set_charset($mysqli, DATABASE_CHARSET);

	$favicon_b64data = base64_encode(file_get_contents(DATA_PATHDIR . FAVICON_FILENAME));
?>
<!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="application-name" content="<?=THIS_TITLE . ' v' . THIS_VERSION . ' ' . THIS_COPYR?>">
		<link href="<?='data:' . IMAGE_DATA_MIME . ';base64,' . $favicon_b64data?>" rel="icon" type="<?=IMAGE_DATA_MIME?>">
<?php

if (isset($_GET['admin'])) {
// begin of admin mode
?>
		<style type="text/css">.btnRed {background: #ffd0d0; line-height: 2;} .btnYellow {background: #ffffd0; line-height: 2;} .btnGreen {background: #d0ffd0; line-height: 2;}</style>
		<title><?=THIS_TITLE?> ADMIN</title>
	</head>
	<body>
<?php
	if (isset($_POST['admpass'])) {
		setcookie('admpass', (string) $_POST['admpass']);
	}
	$admpass = (string) ( isset($_POST['admpass']) ? $_POST['admpass'] : (isset($_COOKIE['admpass']) ? $_COOKIE['admpass'] : '') );
	if (hash('sha256', $admpass) == ADMINPASS_SHA256HASH) { // authentication done

		$action_done = false;

		// Check if some action was requested
		if (isset($_POST['do_sendlinks'])) {

			if (!THIS_IS_LOCAL) { // don't actually send emails if local
				$query = "SELECT * FROM `participants` WHERE `linksent`=0";
				if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
					terminate(ERRSTR_DB_ERR);
				}
				$emails_sent_num = 0;
				$emails_accepted_num = 0;
				set_time_limit(SCRIPTIME_MAILSEND_LIMIT);
				while ($participant = $qresult->fetch_assoc()) {
					$emails_sent_num++;
					if (mail(trim($participant['email']), PARTICIPANT_EMAIL_SUBJECT, wordwrap(PARTICIPANT_LINK_PREFIX . $participant['id'], 70), 'From: ' . PARTICIPANT_EMAIL_SENDER)) {
						$emails_accepted_num++;
						$id = $participant['id'];
						$query = "UPDATE `participants` SET `linksent`=1 WHERE `id`='{$id}'";
						if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) { // one-by-one is slower, but acceptance count should be more reliable...
							terminate(ERRSTR_DB_ERR);
						}
					}
				}
				$qresult->free();
?>
		<p>Links were sent to non-informed participants who are marked as informed now.</p>
		<p>Of <?=$emails_sent_num?> emails sent, <?=$emails_accepted_num?> were accepted (but not guaranteed to be actually received).</p>
<?php
			} else {
?>
		<p>Due to LOCAL mode, links were not sent.</p>
<?php
			}

			$action_done = true;
		} else if (isset($_POST['do_sendlink_input_group'])) {
?>
		<p><i>Send link to single participant's email: step 1/2</i></p>

		<form action="<?=THISCRIPT?>?admin" method="post">
			<p>Group <select name="adm_sendlink_group">
<?php
			$query = "SELECT DISTINCT `gruppe` FROM `participants` WHERE 1 ORDER BY `gruppe`";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			while ($group = $qresult->fetch_assoc()) {
?>
				<option value="<?=$group['gruppe']?>"><?=$group['gruppe']?></option>
<?php
			}
			$qresult->free();
?>
			</select></p>
			<input type="submit" name="do_sendlink_input_participant" value="OK">
			<input type="submit" name="show_menu" value="Cancel">
		</form>
<?php
			// $action_done remains false, we don't need another OK button
		} else if (isset($_POST['do_sendlink_input_participant'])) {
			$adm_sendlink_group = str_rm_quotes($_POST['adm_sendlink_group']);			
?>
		<p><i>Send link to single participant's email: step 2/2</i></p>

		<form action="<?=THISCRIPT?>?admin" method="post">
			<p>Group &laquo;<?=$adm_sendlink_group?>&raquo;, participant <select name="adm_sendlink_participant_id">
<?php
			$query = "SELECT `id`, `name` FROM `participants` WHERE `gruppe`='{$adm_sendlink_group}' ORDER BY `name`";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			while ($participant = $qresult->fetch_assoc()) {
?>
				<option value="<?=$participant['id']?>"><?=$participant['name']?></option>
<?php
			}
			$qresult->free();
?>
			</select></p>
			<input type="submit" name="do_sendlink_send" value="Send">
			<input type="submit" name="show_menu" value="Cancel">
		</form>
<?php
			// $action_done remains false, we don't need another OK button
		} else if (isset($_POST['do_sendlink_send'])) {

			if (!THIS_IS_LOCAL) { // don't actually send email if local
				$adm_sendlink_participant_id = str_rm_quotes($_POST['adm_sendlink_participant_id']);
				if (!check_id_str($adm_sendlink_participant_id)) {
					terminate(ERRSTR_ID_ERR);
				}
				$query = "SELECT * FROM `participants` WHERE `id`='{$adm_sendlink_participant_id}'";
				if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
					terminate(ERRSTR_DB_ERR);
				}
				if ($qresult->num_rows == 0) {
					terminate(ERRSTR_ID_NOT_FOUND);
				}
				$participant = $qresult->fetch_assoc();
				$email_accepted = false;
				set_time_limit(SCRIPTIME_MAILSEND_LIMIT);
				if (mail(trim($participant['email']), PARTICIPANT_EMAIL_SUBJECT, wordwrap(PARTICIPANT_LINK_PREFIX . $participant['id'], 70), 'From: ' . PARTICIPANT_EMAIL_SENDER)) {
					$email_accepted = true;
					$query = "UPDATE `participants` SET `linksent`=1 WHERE `id`='{$adm_sendlink_participant_id}'";
					if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
						terminate(ERRSTR_DB_ERR);
					}
				}
				$qresult->free();
?>
		<p>Link was sent to the participant.</p>
<?php
				if ($email_accepted) {
?>
		<p>Email was accepted (but not guaranteed to be actually received).</p>
<?php
				} else {
?>
		<p>Email was not accepted.</p>
<?php
				}
			} else {
?>
		<p>Due to LOCAL mode, link was not sent.</p>
<?php
			}

			$action_done = true;
		} else if (isset($_POST['do_set_exam_by_template_input'])) {
?>
		<form action="<?=THISCRIPT?>?admin" method="post">
			<p>Set exam <select name="adm_setexam_exam">
				<option value="">&laquo;NO EXAM&raquo;</option>
<?php
			$query = "SELECT `exam` FROM `exams` WHERE 1 ORDER BY `exam`";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			while ($exam = $qresult->fetch_assoc()) {
?>
				<option value="<?=$exam['exam']?>"><?=$exam['exam']?></option>
<?php
			}
			$qresult->free();
?>
			</select></p>
			<p>for participants whose groups match template	<input type="text" name="adm_setexam_grouptemplate" maxlength=256></p>
			<p><i>Wildcards in template: "%" is arbitrary substring (including empty), "_" is 1 arbitrary symbol.</i></p>
			<p><b>Warning: no sanity checks except for removing quotes, be careful.</b></p>
			<input type="submit" name="do_set_exam_by_template_set" value="Set">
			<input type="submit" name="show_menu" value="Cancel">
		</form>
<?php
			// $action_done remains false, we don't need another OK button
		} else if (isset($_POST['do_set_exam_by_template_set'])) {
			$adm_setexam_exam = str_rm_quotes($_POST['adm_setexam_exam']);
			$adm_setexam_grouptemplate = str_rm_quotes($_POST['adm_setexam_grouptemplate']);

			$query = "SELECT `id` FROM `participants` WHERE `gruppe` LIKE '{$adm_setexam_grouptemplate}'";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$affected_num = $qresult->num_rows;
			$qresult->free();

			if ($affected_num > 0) {
				$query = "UPDATE `participants` SET `exam`='$adm_setexam_exam', `var`=0, `chtime`='' WHERE `gruppe` LIKE '{$adm_setexam_grouptemplate}'";
				if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
					terminate(ERRSTR_DB_ERR);
				}
			}
?>
		<p>Exam has been set for <?=$affected_num?> participants whose groups matched template.</p>
<?php
			$action_done = true;
		} else if (isset($_POST['do_set_exam_by_select_input'])) {
?>
		<form action="<?=THISCRIPT?>?admin" method="post">
			<p>Set exam <select name="adm_setexam_exam">
				<option value="">&laquo;NO EXAM&raquo;</option>
<?php
			$query = "SELECT `exam` FROM `exams` WHERE 1 ORDER BY `exam`";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			while ($exam = $qresult->fetch_assoc()) {
?>
				<option value="<?=$exam['exam']?>"><?=$exam['exam']?></option>
<?php
			}
			$qresult->free();
?>
			</select></p>
			<p>for participants from groups <select name="adm_setexam_selgroups[]" multiple>
<?php
			$query = "SELECT DISTINCT `gruppe` FROM `participants` WHERE 1 ORDER BY `gruppe`";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			while ($group = $qresult->fetch_assoc()) {
?>
				<option value="<?=$group['gruppe']?>"><?=$group['gruppe']?></option>
<?php
			}
			$qresult->free();
?>
			</select></p>
			<input type="submit" name="do_set_exam_by_select_set" value="Set">
			<input type="submit" name="show_menu" value="Cancel">
		</form>
<?php
			// $action_done remains false, we don't need another OK button
		} else if (isset($_POST['do_set_exam_by_select_set'])) {
			$affected_num = 0;

			$adm_setexam_exam = str_rm_quotes($_POST['adm_setexam_exam']);
			$adm_setexam_selgroups = str_rm_quotes($_POST['adm_setexam_selgroups']);

			if (count($adm_setexam_selgroups) > 0) {
				$adm_setexam_selgroups_str = "'" . implode("', '", $adm_setexam_selgroups) . "'";

				$query = "SELECT `id` FROM `participants` WHERE `gruppe` IN ({$adm_setexam_selgroups_str})";
				if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
					terminate(ERRSTR_DB_ERR);
				}
				$affected_num = $qresult->num_rows;
				$qresult->free();

				if ($affected_num > 0) {
					$query = "UPDATE `participants` SET `exam`='{$adm_setexam_exam}', `var`=0, `chtime`='' WHERE `gruppe` IN ({$adm_setexam_selgroups_str})";
					if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
						terminate(ERRSTR_DB_ERR);
					}
				}
			}
?>
		<p>Exam has been set for <?=$affected_num?> participants from selected groups.</p>
<?php
			$action_done = true;
		} else if (isset($_POST['do_reset_exam_keep_choices'])) {

			$query = "UPDATE `participants` SET `exam`='' WHERE 1";
			if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
?>
		<p>All participants were reset to &laquo;no exam&raquo;, choices kept.</p>
<?php

			$action_done = true;
		} else if (isset($_POST['do_reset_exam_clear_choices'])) {

			$query = "UPDATE `participants` SET `exam`='', `var`=0, `chtime`='' WHERE 1";
			if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
?>
		<p>All participants were reset to &laquo;no exam&raquo;, choices cleared.</p>
<?php

			$action_done = true;
		} else if (isset($_POST['do_clear_ips'])) {

			$query = "UPDATE `participants` SET `ips`='' WHERE 1";
			if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
?>
		<p>IPs of participants' pagevisits were cleared.</p>
<?php

			$action_done = true;
		} else if (isset($_POST['show_statistics'])) {
			if (!$qresult = $mysqli->query("SELECT `exam` FROM `exams` WHERE 1", MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$stat_exams_total = $qresult->num_rows;
			$qresult->free();

			if (!$qresult = $mysqli->query("SELECT `id` FROM `participants` WHERE 1", MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$stat_participants_total = $qresult->num_rows;
			$qresult->free();

			if (!$qresult = $mysqli->query("SELECT `id` FROM `participants` WHERE `exam`<>''", MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$stat_assigned = $qresult->num_rows;
			$qresult->free();

			if (!$qresult = $mysqli->query("SELECT `id` FROM `participants` WHERE `var`>0", MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$stat_chosen = $qresult->num_rows;
			$qresult->free();

			if (!$qresult = $mysqli->query("SELECT `id` FROM `participants` WHERE `linksent`=1", MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			$stat_linksent = $qresult->num_rows;
			$qresult->free();
?>
		<p><i>Statistics</i></p>
		<p>Exams: <b><?=$stat_exams_total?></b></p>
		<p>Participants: <b><?=$stat_participants_total?></b></p>
		<p>of them</p>
		<p>&ndash; link sent: <b><?=$stat_linksent?></b></p>
		<p>&ndash; exam assigned: <b><?=$stat_assigned?></b></p>
		<p>&ndash; choice made: <b><?=$stat_chosen?></b></p>
<?php

			$action_done = true;
		} else if (isset($_POST['show_ip_collisions'])) {
			$ips = array();
			$query = "SELECT * FROM `participants` WHERE `ips`<>''";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			// Gather all IPs
			while ($participant = $qresult->fetch_assoc()) {
				$part_ips = explode(';', $participant['ips']); // won't be array('') because at least 1 IP is there
				foreach ($part_ips as $ip) {
					if (!in_array($ip, $ips)) {
						$ips[] = $ip;
					}
				}
			}
			$qresult->free();
			sort($ips);
			// Check each IP, if there's a collision, append info to output html
			$collisions_html = '';
			foreach ($ips as $ip) {
				$query = "SELECT * FROM `participants` WHERE `ips` LIKE '%{$ip}%' ORDER BY `name`, `gruppe`"; // shouldn't appear not as itself in string of IPs emploded with ';'...
				if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
					terminate(ERRSTR_DB_ERR);
				}
				if ($qresult->num_rows > 1) { // collision
					$collided_participants = array();
					$collisions_html .= '<p><b>' . $ip . '</b> : ';
					while ($participant = $qresult->fetch_assoc()) {
						$collided_participants[] = '<span title="' . $participant['id'] . '">' . $participant['name'] . ' (' . $participant['gruppe'] . ')</span>';
					}
					$collisions_html .= implode(' <b>&amp;</b> ', $collided_participants);
					$collisions_html .= "</p>\n";
				}
				$qresult->free();
			}
?>
		<p><i>IP collisions</i></p>
		<?=$collisions_html?>
<?php

			$action_done = true;
		} else { // no action was requested, display action menu
?>		
		<form action="<?=THISCRIPT?>?admin" method="post">
			<p>Actions that change the world outside:</p>
			<input class="btnRed" type="submit" name="do_sendlinks" value="Send links to non-informed participants' emails, mark them as informed (takes some time)">
			<br><br>
			<input class="btnRed" type="submit" name="do_sendlink_input_group" value="Send link to single participant's email">

			<hr>
			<p>Actions that change the database only:</p>
			<input class="btnYellow" type="submit" name="do_set_exam_by_template_input" value="Set exam for participants whose groups match template (clears choices)">
			<br><br>
			<input class="btnYellow" type="submit" name="do_set_exam_by_select_input" value="Set exam for participants from selected groups (clears choices)">
			<br><br>
			<input class="btnYellow" type="submit" name="do_reset_exam_keep_choices" value="Reset all participants to &laquo;no exam&raquo;, keep choices">
			<br><br>
			<input class="btnYellow" type="submit" name="do_reset_exam_clear_choices" value="Reset all participants to &laquo;no exam&raquo;, clear choices">
			<br><br>
			<input class="btnYellow" type="submit" name="do_clear_ips" value="Clear IPs of participants' pagevisits">

			<hr>
			<p>Actions that change nothing:</p>
			<input class="btnGreen" type="submit" name="show_statistics" value="Show statistics">
			<br><br>
			<input class="btnGreen" type="submit" name="show_ip_collisions" value="Show IP collisions">
		</form>
<?php
		}

		if ($action_done) { // show OK button, which returns to menu
?>
		<form action="<?=THISCRIPT?>?admin" method="post">
			<input type="submit" name="show_menu" value="OK">
		</form>
<?php
		}

	} else { // request password
?>
		<p>Obviously, you know the password...</p>
		<form action= "<?=THISCRIPT?>?admin" method="post">
			<input type="password" name='admpass' maxlength="256" autofocus>
		</form>
<?php
	}
// end of admin mode
} else {
// begin of participant mode
?>
		<style type="text/css">#REemblem {position: fixed; top: <?=EMBLEM_MARGIN?>px; right: <?=EMBLEM_MARGIN?>px; opacity: <?=EMBLEM_OPACITY?>; transition: right <?=EMBLEM_JUMPDURATION?>s ease, top <?=EMBLEM_JUMPDURATION?>s ease;} #REemblem:hover {right: -<?=EMBLEM_SIZE+EMBLEM_MARGIN?>px; top: -<?=EMBLEM_SIZE+EMBLEM_MARGIN?>px;}</style>
		<title><?=THIS_TITLE?></title>
	</head>
	<body>
<?php

if (isset($_GET['id'])) {
	$id = (string) $_GET['id']; // does casting to string change anything? make it safer?

	if (check_id_str($id)) {
		$query = "SELECT * FROM `participants` WHERE `id`='{$id}'"; // id key is primary and so must be unique (if present)...
		if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
			terminate(ERRSTR_DB_ERR);
		}
		if ($qresult->num_rows == 0) {
			terminate(ERRSTR_ID_NOT_FOUND);
		}

		$participant = $qresult->fetch_assoc();
		$qresult->free();

		if (isset($_SERVER['REMOTE_ADDR'])) {
			$ip = (string) $_SERVER['REMOTE_ADDR'];
			if ((strlen($ip) <= MAX_IP_STRING_LENGTH) && (strspn($ip, IP_ALLOWED_CHARS) == strlen($ip))) { // format check: $ip is not too long and consists of ., :, ..., F only; non-exact test...
				$ips = ($participant['ips'] != '') ? explode(';', $participant['ips']) : array();
				if ( (count($ips) < MAX_STORED_IP_ADDRESSES) && (!in_array($ip, $ips)) ) {
					$ips[] = $ip;
					$ips = implode(";", $ips);
					// Update ips in DB...
					$query = "UPDATE `participants` SET `ips`='{$ips}' WHERE `id`='{$id}'";
					if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
						terminate(ERRSTR_DB_ERR);
					}
					// ...and here in script
					$participant['ips'] = $ips;
				}
			}
		}

		$participant_fullname_html = '<b>' . $participant['name'] . '</b>, ' . $participant['gruppe'] . ' (<i>' . $participant['email'] . '</i>)';
?>
		<p><?=$participant_fullname_html?></p>
<?php
		$exam_id = $participant['exam'];

		if ($exam_id != '') { // '' means "no exam now"
			$query = "SELECT * FROM `exams` WHERE `exam`='{$exam_id}'";
			if (!$qresult = $mysqli->query($query, MYSQLI_STORE_RESULT)) {
				terminate(ERRSTR_DB_ERR);
			}
			if ($qresult->num_rows == 0) {
				terminate(ERRSTR_EXAM_NOT_FOUND);
			}

			$exam = $qresult->fetch_assoc();
			$qresult->free();

			$exam_name = $exam['name'];
?>
		<p><u><?=$exam_name?></u></p>
<?php
			$varnum = 0;
			while (file_exists(DATA_PATHDIR . $exam_id . '/' . VARIMG_FILENAME_PREFIX . (string)($varnum + 1) . IMAGE_FILE_EXT)) {
				$varnum++;
			}
			if ($varnum == 0) {
				terminate(ERRSTR_VARS_NOT_FOUND);
			}

			$var = $participant['var'];

			if ( !(($var >= 1) && ($var <= $varnum)) ) { // must choose; check if choice (salt) was made and correct, if so, calculate var
				$salt_valid = true;
				for ($i = 1; $i <= SALT_STRING_LENGTH; $i++) {
					if (isset($_POST['s' . $i])) {
						$digit = (string) $_POST['s' . $i];
						if ( !((strlen($digit) == 1) && ctype_digit($digit)) ) { // another format check
							$salt_valid = false;
							break;
						}
					} else {
						$salt_valid = false;
						break;
					}
				}

				if ($salt_valid) {
					$salt = '';
					for ($i = 1; $i <= SALT_STRING_LENGTH; $i++) {
						$salt .= (string) $_POST['s' . $i];
					}
					$hashstr = hash('sha256', HASHCALC_INSALT . $id . HASHCALC_INSALT . $salt . HASHCALC_INSALT);

					$var = 1 + (intval(substr($hashstr, 0, 7), 0x10) % $varnum); // max substr() is '0xFFFFFFF', not truncated by intval() on 32/64-bit arch

					$chtime = date('Y.m.d D H:i:s');

					// update this participant in DB...
					$query = "UPDATE `participants` SET `var`='{$var}', `chtime`='{$chtime}' WHERE `id`='{$id}'";
					if (!$mysqli->query($query, MYSQLI_STORE_RESULT)) {
						terminate(ERRSTR_DB_ERR);
					}

					// ..and here in script
					$participant['var'] = $var;
					$participant['chtime'] = $chtime;
				}
			}

			// Has var become valid?
			if (($var >= 1) && ($var <= $varnum)) { // participant has made a choice (salt), var is calculated, show it
				$varsdirpath = DATA_PATHDIR . $exam_id . '/';

				$varimg_path = $varsdirpath . VARIMG_FILENAME_PREFIX . $var . IMAGE_FILE_EXT;
				$veilimg_path = $varsdirpath . VEILIMG_FILENAME;
				$varimg_b64data = base64_encode(file_get_contents($varimg_path));
				$veilimg_b64data = base64_encode(file_get_contents($veilimg_path));
?>
		<table border=1><tr><td>
			<img src="<?='data:' . IMAGE_DATA_MIME . ';base64,' . $varimg_b64data?>" style="position: absolute; z-index: -2;">
			<img src="<?='data:' . IMAGE_DATA_MIME . ';base64,' . $veilimg_b64data?>">
		</td></tr></table>
		<p><?=$exam['comment']?></p>
<?php
			} else { // participant must make a choice (salt)
?>
		<p><?=LOCALE_INSTRUCT_CHOICE?></p>
		<form action="<?=THISCRIPT?>?id=<?=$id?>" method="post">
			<table border=1>
<?php
				for ($row = 1; $row <= SALT_STRING_LENGTH; $row++) {
?>
				<tr><td>
					<label><input type="radio" name="s<?=$row?>" value=0 checked>0</label>
<?php
					for ($col = 1; $col <= 9; $col++) {
?>
					<label><input type="radio" name="s<?=$row?>" value=<?=$col?>><?=$col?></label>
<?php
					}
?>
				</td></tr>						
<?php
				}
?>
			</table>
			<p><input type="submit" value="OK" autofocus></p>
		</form>
<?php
			}

		} else { // no exam for this participant now
			$emblem_b64data = base64_encode(file_get_contents(DATA_PATHDIR . EMBLEM_FILENAME));
?>
		<p><u><?=LOCALE_NO_EXAM_NOW?></u></p>
		<a href="<?=EMBLEM_HREF?>" target="_blank"><img id="REemblem" src="<?='data:' . IMAGE_DATA_MIME . ';base64,' . $emblem_b64data?>"></a>
<?php
		}
?>
		<hr>
		<p style="font-size: 75%;"><?=LOCALE_PAGE_VISITORS?> <b><?=str_replace(';', ', ', $participant['ips'])?></b></p>
<?php
	} else {
		terminate(ERRSTR_ID_ERR);
	}
} else {
	terminate(ERRSTR_ID_NONE);
}
// end of participant mode
}

$mysqli->close();
?>
	</body>
</html>
